<?php

/**
 * This code was generated by
 * \ / _    _  _|   _  _
 * | (_)\/(_)(_|\/| |(/_  v1.0.0
 * /       /
 */

namespace Twilio\Rest\Verify\V2;

use Twilio\Exceptions\TwilioException;
use Twilio\InstanceContext;
use Twilio\Values;
use Twilio\Version;

/**
 * PLEASE NOTE that this class contains beta products that are subject to change. Use them with caution.
 */
class FormContext extends InstanceContext {
    /**
     * Initialize the FormContext
     *
     * @param Version $version Version that contains the resource
     * @param string $formType The Type of this Form
     */
    public function __construct(Version $version, $formType) {
        parent::__construct($version);

        // Path Solution
        $this->solution = ['formType' => $formType, ];

        $this->uri = '/Forms/' . \rawurlencode($formType) . '';
    }

    /**
     * Fetch the FormInstance
     *
     * @return FormInstance Fetched FormInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch(): FormInstance {
        $payload = $this->version->fetch('GET', $this->uri);

        return new FormInstance($this->version, $payload, $this->solution['formType']);
    }

    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString(): string {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "$key=$value";
        }
        return '[Twilio.Verify.V2.FormContext ' . \implode(' ', $context) . ']';
    }
}